// LRTesterDlg.cpp : implementation file
//

#include "stdafx.h"
#include <afxdlgs.h>
#include "LRTester.h"
#include "chiSq1.h"
#include "Comenta.h"
#include "LRTesterDlg.h"
#include "salvando.h"
#include "string.h"

#define GTRFP 8
#define TRNFP 5
#define HKYFP 4
#define F81FP 3
#define K2PFP 1
#define JCFP 0

#ifdef _DEBUG
#define new DEBUG_NEW


#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	float CHISQ(float p, int df);
	float Pi;
	float PVAL(float x, int df);
	CAboutDlg();


// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLRTesterDlg dialog

CLRTesterDlg::CLRTesterDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLRTesterDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CLRTesterDlg)
	m_bClockTest = FALSE;
	m_bModelTest = FALSE;
	m_fPVALUE = 0.05f;
	m_bF81 = FALSE;
	m_bGTR = FALSE;
	m_bHKY = FALSE;
	m_bJC = FALSE;
	m_bK2P = FALSE;
	m_bTRN = FALSE;
	m_fF81IN = 0.0f;
	m_fGTRIN = 0.0f;
	m_fHKYIN = 0.0f;
	m_fJCIN = 0.0f;
	m_fK2PIN = 0.0f;
	m_fTRNIN = 0.0f;
	m_bF81G = FALSE;
	m_bGTRG = FALSE;
	m_bHKYG = FALSE;
	m_bJCG = FALSE;
	m_bK2PG = FALSE;
	m_bTRNG = FALSE;
	m_bF81I = FALSE;
	m_bGTRI = FALSE;
	m_bHKYI = FALSE;
	m_bJCI = FALSE;
	m_bK2PI = FALSE;
	m_bTRNI = FALSE;
	m_sF81LRT = _T("");
	m_sHKYLRT = _T("");
	m_sJCLRT = _T("");
	m_sK2PLRT = _T("");
	m_sTRNLRT = _T("");
	m_sF81CV = _T("");
	m_sHKYCV = _T("");
	m_sJCCV = _T("");
	m_sK2PCV = _T("");
	m_sTRNCV = _T("");
	m_sF81RES = _T("");
	m_sHKYRES = _T("");
	m_sJCRES = _T("");
	m_sK2PRES = _T("");
	m_sTRNRES = _T("");
	m_iTAXA = 0;
	m_fCLOCKLNL = 0.0f;
	m_fNOCLOCKLNL = 0.0f;
	m_sCLOCKRES = _T("");
	m_sClockLRT = _T("");
	m_sCLCRITRES = _T("");
	m_bGAMATEST = FALSE;
	m_sGCRITRES = _T("");
	m_sGLRT = _T("");
	m_sGAMARES = _T("");
	m_fGAMALNL = 0.0f;
	m_fNOGAMALNL = 0.0f;
	m_bSalva = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}


void CLRTesterDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CLRTesterDlg)
	DDX_Check(pDX, IDC_CLOCKTEST, m_bClockTest);
	DDX_Check(pDX, IDC_MODELTEST, m_bModelTest);
	DDX_Text(pDX, IDC_PVALUE, m_fPVALUE);
	DDX_Check(pDX, IDC_F81, m_bF81);
	DDX_Check(pDX, IDC_GTR, m_bGTR);
	DDX_Check(pDX, IDC_HKY, m_bHKY);
	DDX_Check(pDX, IDC_JC, m_bJC);
	DDX_Check(pDX, IDC_K2P, m_bK2P);
	DDX_Check(pDX, IDC_TRN, m_bTRN);
	DDX_Text(pDX, IDC_F81IN, m_fF81IN);
	DDX_Text(pDX, IDC_GTRIN, m_fGTRIN);
	DDX_Text(pDX, IDC_HKY85IN, m_fHKYIN);
	DDX_Text(pDX, IDC_JCIN, m_fJCIN);
	DDX_Text(pDX, IDC_K2PIN, m_fK2PIN);
	DDX_Text(pDX, IDC_TRNIN, m_fTRNIN);
	DDX_Check(pDX, IDC_F81G, m_bF81G);
	DDX_Check(pDX, IDC_GTRG, m_bGTRG);
	DDX_Check(pDX, IDC_HKY85G, m_bHKYG);
	DDX_Check(pDX, IDC_JCG, m_bJCG);
	DDX_Check(pDX, IDC_K2PG, m_bK2PG);
	DDX_Check(pDX, IDC_TRNG, m_bTRNG);
	DDX_Check(pDX, IDC_F81I, m_bF81I);
	DDX_Check(pDX, IDC_GTRI, m_bGTRI);
	DDX_Check(pDX, IDC_HKY85I, m_bHKYI);
	DDX_Check(pDX, IDC_JCI, m_bJCI);
	DDX_Check(pDX, IDC_K2PI, m_bK2PI);
	DDX_Check(pDX, IDC_TRNI, m_bTRNI);
	DDX_Text(pDX, IDC_F81LRT, m_sF81LRT);
	DDX_Text(pDX, IDC_HKY85LRT, m_sHKYLRT);
	DDX_Text(pDX, IDC_JCLRT, m_sJCLRT);
	DDX_Text(pDX, IDC_K2PLRT, m_sK2PLRT);
	DDX_Text(pDX, IDC_TRNLRT, m_sTRNLRT);
	DDX_Text(pDX, IDC_F81CV, m_sF81CV);
	DDX_Text(pDX, IDC_HKYCV, m_sHKYCV);
	DDX_Text(pDX, IDC_JCCV, m_sJCCV);
	DDX_Text(pDX, IDC_K2PCV, m_sK2PCV);
	DDX_Text(pDX, IDC_TRNCV, m_sTRNCV);
	DDX_Text(pDX, IDC_F81RES, m_sF81RES);
	DDX_Text(pDX, IDC_HKY85RES, m_sHKYRES);
	DDX_Text(pDX, IDC_JCRES, m_sJCRES);
	DDX_Text(pDX, IDC_K2PRES, m_sK2PRES);
	DDX_Text(pDX, IDC_TRNRES, m_sTRNRES);
	DDX_Text(pDX, IDC_TAXA, m_iTAXA);
	DDX_Text(pDX, IDC_CLOCKLNL, m_fCLOCKLNL);
	DDX_Text(pDX, IDC_NOCLOCKLNL, m_fNOCLOCKLNL);
	DDX_Text(pDX, IDC_CLOCKRES, m_sCLOCKRES);
	DDX_Text(pDX, IDC_CLOCKLRT2, m_sClockLRT);
	DDX_Text(pDX, IDC_CLCRITRES, m_sCLCRITRES);
	DDX_Check(pDX, IDC_GAMATEST, m_bGAMATEST);
	DDX_Text(pDX, IDC_GCRITRES, m_sGCRITRES);
	DDX_Text(pDX, IDC_GLRT, m_sGLRT);
	DDX_Text(pDX, IDC_GAMARES, m_sGAMARES);
	DDX_Text(pDX, IDC_GAMALNL, m_fGAMALNL);
	DDX_Text(pDX, IDC_NOGAMALNL, m_fNOGAMALNL);
	DDX_Check(pDX, IDC_SALVA, m_bSalva);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CLRTesterDlg, CDialog)
	//{{AFX_MSG_MAP(CLRTesterDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDCLOSE, OnClose)
	ON_BN_CLICKED(IDC_MODELTEST, OnModeltest)
	ON_BN_CLICKED(IDC_CLOCKTEST, OnClocktest)
	ON_BN_CLICKED(IDCLEAR, OnClear)
	ON_BN_CLICKED(IDC_CHISQCALC, OnChisqcalc)
	ON_BN_CLICKED(IDCalculate, OnCalculate)
	ON_BN_CLICKED(IDC_GAMATEST, OnGamatest)
	ON_BN_CLICKED(ID_DEFAULT_HELP, OnHelp)
	ON_BN_CLICKED(IDFNAME, OnSalva)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CLRTesterDlg message handlers

BOOL CLRTesterDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here


	m_bClockTest =TRUE;
	m_bModelTest =TRUE;
	m_bGAMATEST = TRUE;
	UpdateData(FALSE);


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CLRTesterDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CLRTesterDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CLRTesterDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CLRTesterDlg::OnClose() 
{
OnOK();
}

void CLRTesterDlg::OnModeltest() 
{
UpdateData(TRUE);

if (m_bModelTest == TRUE)

{

GetDlgItem(IDC_JC)->EnableWindow(TRUE);
GetDlgItem(IDC_K2P)->EnableWindow(TRUE);
GetDlgItem(IDC_F81)->EnableWindow(TRUE);
GetDlgItem(IDC_HKY)->EnableWindow(TRUE);
GetDlgItem(IDC_TRN)->EnableWindow(TRUE);
GetDlgItem(IDC_GTR)->EnableWindow(TRUE);
GetDlgItem(IDC_JCG)->EnableWindow(TRUE);
GetDlgItem(IDC_K2PG)->EnableWindow(TRUE);
GetDlgItem(IDC_F81G)->EnableWindow(TRUE);
GetDlgItem(IDC_HKY85G)->EnableWindow(TRUE);
GetDlgItem(IDC_TRNG)->EnableWindow(TRUE);
GetDlgItem(IDC_GTRG)->EnableWindow(TRUE);
GetDlgItem(IDC_JCRES)->EnableWindow(TRUE);
GetDlgItem(IDC_K2PRES)->EnableWindow(TRUE);
GetDlgItem(IDC_F81RES)->EnableWindow(TRUE);
GetDlgItem(IDC_HKY85RES)->EnableWindow(TRUE);
GetDlgItem(IDC_TRNRES)->EnableWindow(TRUE);
GetDlgItem(IDC_TRNIN)->EnableWindow(TRUE);
GetDlgItem(IDC_F81IN)->EnableWindow(TRUE);
GetDlgItem(IDC_JCIN)->EnableWindow(TRUE);
GetDlgItem(IDC_K2PIN)->EnableWindow(TRUE);
GetDlgItem(IDC_HKY85IN)->EnableWindow(TRUE);
GetDlgItem(IDC_GTRIN)->EnableWindow(TRUE);
GetDlgItem(IDC_JCI)->EnableWindow(TRUE);
GetDlgItem(IDC_K2PI)->EnableWindow(TRUE);
GetDlgItem(IDC_F81I)->EnableWindow(TRUE);
GetDlgItem(IDC_TRNI)->EnableWindow(TRUE);
GetDlgItem(IDC_GTRI)->EnableWindow(TRUE);
GetDlgItem(IDC_HKY85I)->EnableWindow(TRUE);
GetDlgItem(IDC_TRNLRT)->EnableWindow(TRUE);
GetDlgItem(IDC_JCLRT)->EnableWindow(TRUE);
GetDlgItem(IDC_K2PLRT)->EnableWindow(TRUE);
GetDlgItem(IDC_F81LRT)->EnableWindow(TRUE);
GetDlgItem(IDC_HKY85LRT)->EnableWindow(TRUE);
GetDlgItem(IDC_JCCV)->EnableWindow(TRUE);
GetDlgItem(IDC_K2PCV)->EnableWindow(TRUE);
GetDlgItem(IDC_F81CV)->EnableWindow(TRUE);
GetDlgItem(IDC_HKYCV)->EnableWindow(TRUE);
GetDlgItem(IDC_TRNCV)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICML)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICGAMA)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICINVAR)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICMLRT)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICCV)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICMRES)->EnableWindow(TRUE);

}

 else

 {

GetDlgItem(IDC_JC)->EnableWindow(FALSE);
GetDlgItem(IDC_K2P)->EnableWindow(FALSE);
GetDlgItem(IDC_F81)->EnableWindow(FALSE);
GetDlgItem(IDC_HKY)->EnableWindow(FALSE);
GetDlgItem(IDC_TRN)->EnableWindow(FALSE);
GetDlgItem(IDC_GTR)->EnableWindow(FALSE);
GetDlgItem(IDC_JCG)->EnableWindow(FALSE);
GetDlgItem(IDC_K2PG)->EnableWindow(FALSE);
GetDlgItem(IDC_F81G)->EnableWindow(FALSE);
GetDlgItem(IDC_HKY85G)->EnableWindow(FALSE);
GetDlgItem(IDC_TRNG)->EnableWindow(FALSE);
GetDlgItem(IDC_GTRG)->EnableWindow(FALSE);
GetDlgItem(IDC_JCRES)->EnableWindow(FALSE);
GetDlgItem(IDC_K2PRES)->EnableWindow(FALSE);
GetDlgItem(IDC_F81RES)->EnableWindow(FALSE);
GetDlgItem(IDC_HKY85RES)->EnableWindow(FALSE);
GetDlgItem(IDC_TRNRES)->EnableWindow(FALSE);
GetDlgItem(IDC_TRNIN)->EnableWindow(FALSE);
GetDlgItem(IDC_F81IN)->EnableWindow(FALSE);
GetDlgItem(IDC_JCIN)->EnableWindow(FALSE);
GetDlgItem(IDC_K2PIN)->EnableWindow(FALSE);
GetDlgItem(IDC_HKY85IN)->EnableWindow(FALSE);
GetDlgItem(IDC_GTRIN)->EnableWindow(FALSE);
GetDlgItem(IDC_JCI)->EnableWindow(FALSE);
GetDlgItem(IDC_K2PI)->EnableWindow(FALSE);
GetDlgItem(IDC_F81I)->EnableWindow(FALSE);
GetDlgItem(IDC_TRNI)->EnableWindow(FALSE);
GetDlgItem(IDC_GTRI)->EnableWindow(FALSE);
GetDlgItem(IDC_HKY85I)->EnableWindow(FALSE);
GetDlgItem(IDC_TRNLRT)->EnableWindow(FALSE);
GetDlgItem(IDC_JCLRT)->EnableWindow(FALSE);
GetDlgItem(IDC_K2PLRT)->EnableWindow(FALSE);
GetDlgItem(IDC_F81LRT)->EnableWindow(FALSE);
GetDlgItem(IDC_HKY85LRT)->EnableWindow(FALSE);
GetDlgItem(IDC_JCCV)->EnableWindow(FALSE);
GetDlgItem(IDC_K2PCV)->EnableWindow(FALSE);
GetDlgItem(IDC_F81CV)->EnableWindow(FALSE);
GetDlgItem(IDC_HKYCV)->EnableWindow(FALSE);
GetDlgItem(IDC_TRNCV)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICML)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICGAMA)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICINVAR)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICMLRT)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICCV)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICMRES)->EnableWindow(FALSE);

 }

	
}
void CLRTesterDlg::OnClocktest() 
{
UpdateData(TRUE);

if (m_bClockTest == TRUE)

{
GetDlgItem(IDC_STATICTAXA)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICWC)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICWOC)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICRESCK)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICCLNL)->EnableWindow(TRUE);
GetDlgItem(IDC_CLOCKRES)->EnableWindow(TRUE);
GetDlgItem(IDC_CLOCKLNL)->EnableWindow(TRUE);
GetDlgItem(IDC_NOCLOCKLNL)->EnableWindow(TRUE);
GetDlgItem(IDC_TAXA)->EnableWindow(TRUE);
GetDlgItem(IDC_CLCRITRES)->EnableWindow(TRUE);
GetDlgItem(IDC_CLCRIT)->EnableWindow(TRUE);
GetDlgItem(IDC_CLOCKLRT)->EnableWindow(TRUE);
GetDlgItem(IDC_CLOCKLRT2)->EnableWindow(TRUE);
 }

 else

 {
GetDlgItem(IDC_STATICTAXA)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICWC)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICWOC)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICRESCK)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICCLNL)->EnableWindow(FALSE);
GetDlgItem(IDC_CLOCKRES)->EnableWindow(FALSE);
GetDlgItem(IDC_CLOCKLNL)->EnableWindow(FALSE);
GetDlgItem(IDC_NOCLOCKLNL)->EnableWindow(FALSE);
GetDlgItem(IDC_TAXA)->EnableWindow(FALSE);
GetDlgItem(IDC_CLCRITRES)->EnableWindow(FALSE);
GetDlgItem(IDC_CLCRIT)->EnableWindow(FALSE);
GetDlgItem(IDC_CLOCKLRT)->EnableWindow(FALSE);
GetDlgItem(IDC_CLOCKLRT2)->EnableWindow(FALSE);
 }
	
}


void CLRTesterDlg::OnGamatest() 
{

	UpdateData(TRUE);
	if (m_bGAMATEST == TRUE)

{
GetDlgItem(IDC_STATICWG)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICWOG)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICGLNL)->EnableWindow(TRUE);
GetDlgItem(IDC_STATICRESG)->EnableWindow(TRUE);
GetDlgItem(IDC_NOGAMALNL)->EnableWindow(TRUE);
GetDlgItem(IDC_GAMALRT)->EnableWindow(TRUE);
GetDlgItem(IDC_GCRIT)->EnableWindow(TRUE);
GetDlgItem(IDC_GAMARES)->EnableWindow(TRUE);
GetDlgItem(IDC_GAMALNL)->EnableWindow(TRUE);
GetDlgItem(IDC_GLRT)->EnableWindow(TRUE);
GetDlgItem(IDC_GCRITRES)->EnableWindow(TRUE);
 }

 else

 {
GetDlgItem(IDC_STATICWG)->EnableWindow(FALSE);
GetDlgItem(IDC_GAMALRT)->EnableWindow(FALSE);
GetDlgItem(IDC_GCRIT)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICWOG)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICGLNL)->EnableWindow(FALSE);
GetDlgItem(IDC_STATICRESG)->EnableWindow(FALSE);
GetDlgItem(IDC_NOGAMALNL)->EnableWindow(FALSE);
GetDlgItem(IDC_GAMARES)->EnableWindow(FALSE);
GetDlgItem(IDC_GAMALNL)->EnableWindow(FALSE);
GetDlgItem(IDC_GLRT)->EnableWindow(FALSE);
GetDlgItem(IDC_GCRITRES)->EnableWindow(FALSE);
 }
	
}

void CLRTesterDlg::OnClear() 
{
    analy=1;
    m_fPVALUE=0.05f;
    m_bClockTest = FALSE;
	m_bModelTest = FALSE;
	m_bGAMATEST= FALSE;
	m_bF81 = FALSE;
	m_bGTR = FALSE;
	m_bHKY = FALSE;
	m_bJC = FALSE;
	m_bK2P = FALSE;
	m_bTRN = FALSE;
	m_fF81IN = 0.0f;
	m_fGTRIN = 0.0f;
	m_fHKYIN = 0.0f;
	m_fJCIN = 0.0f;
	m_fK2PIN = 0.0f;
	m_fTRNIN = 0.0f;
	m_bF81G = FALSE;
	m_bGTRG = FALSE;
	m_bHKYG = FALSE;
	m_bJCG = FALSE;
	m_bK2PG = FALSE;
	m_bTRNG = FALSE;
	m_bF81I = FALSE;
	m_bGTRI = FALSE;
	m_bHKYI = FALSE;
	m_bJCI = FALSE;
	m_bK2PI = FALSE;
	m_bTRNI = FALSE;
	m_sF81LRT = _T("");
	m_sHKYLRT = _T("");
	m_sJCLRT = _T("");
	m_sK2PLRT = _T("");
	m_sTRNLRT = _T("");
	m_sF81CV = _T("");
	m_sHKYCV = _T("");
	m_sJCCV = _T("");
	m_sK2PCV = _T("");
	m_sTRNCV = _T("");
	m_sF81RES = _T("");
	m_sHKYRES = _T("");
	m_sJCRES = _T("");
	m_sK2PRES = _T("");
	m_sTRNRES = _T("");
	m_iTAXA = 0;
	m_fCLOCKLNL = 0.0f;
	m_fNOCLOCKLNL = 0.0f;
	m_sCLOCKRES = _T("");
	m_sClockLRT = _T("");
	m_fGAMALNL = 0.0f;
	m_fNOGAMALNL = 0.0f;
	m_sGAMARES = _T("");
	m_sGLRT = _T("");
	m_sGCRITRES = _T("");
UpdateData(FALSE);
}

void CLRTesterDlg::ClearModel()
{
	m_sF81LRT = _T("");
	m_sHKYLRT = _T("");
	m_sJCLRT = _T("");
	m_sK2PLRT = _T("");
	m_sTRNLRT = _T("");
	m_sF81CV = _T("");
	m_sHKYCV = _T("");
	m_sJCCV = _T("");
	m_sK2PCV = _T("");
	m_sTRNCV = _T("");
	m_sF81RES = _T("");
	m_sHKYRES = _T("");
	m_sJCRES = _T("");
	m_sK2PRES = _T("");
	m_sTRNRES = _T("");

UpdateData(FALSE);

}


float PVAL(float x, int df)
{
    float Pi=3.14159265359f;
	float p=(float)exp(-0.5*x);
	if ((df%2)==1) { p=p*(float)sqrt(2*x/Pi); };
    int k=df;
	while (k>=2) { p=p*x/k; k=k-2; };
    float t=p;
	int a=df;
	while(t>0.000001*p) { a=a+2; t=t*x/a; p=p+t; };
    if (1-p<1e-6) { return (float)1e-6;}
	else {return 1-p;}

}

float CHISQ(float p, int df)
{
 float v=0.5;
 float dv=0.5;
 float x=0;

 while(dv>1e-6)
 { x=1/v-1; 
   dv=dv/2; 
     if (PVAL(x,df)>p) { v=v-dv; } else { v=v+dv; } }


 return x;
}

void Calcula(float lnl1, float lnl2, CString &s, CString &crit, CString &res, int df, float PV)
{
float lres;
float pv;

	
	lres=2*(float)fabs(lnl1-lnl2);
	 s.Format("%.2f",res);	 

	   if (lres<CHISQ(PV,df)) 
	   {
          pv=PVAL(lres,df);
		  crit.Format("%.4f", CHISQ(PV,df));
		  res.Format("NOT rejected  (p %.6f)",pv);
		  s.Format("%.2f", lres);
	   }
	   else
	   {
		   pv=PVAL(lres,df);
		   crit.Format("%.4f", CHISQ(PV,df));
		   res.Format("Rejected      (p %.6f)", pv);
		   s.Format("%.2f", lres);
	   }

}


void CLRTesterDlg::OnChisqcalc() 
{
if (m_dChiSq.DoModal () == IDOK)

   {
   UpdateData(FALSE);              
   }
}

void CLRTesterDlg::OnCalculate() 
{
float LNLMAX, LNLATUAL;
int FPMAX, FPATUAL;

	UpdateData(TRUE);
    ClearModel();
// ************* calculo de LRT de clock


if (m_bClockTest==FALSE && m_bModelTest==FALSE && m_bGAMATEST==FALSE)
{
MessageBox("Calculate what? \nPlease choose some type of analysis!"); 
}

	
if (m_bClockTest==TRUE && m_fCLOCKLNL!=0 && m_fNOCLOCKLNL!=0 && m_iTAXA!=0)  
	{
	Calcula(m_fNOCLOCKLNL, m_fCLOCKLNL, m_sClockLRT, m_sCLCRITRES, m_sCLOCKRES, m_iTAXA-2, m_fPVALUE);
	}

if (m_bClockTest==TRUE && (m_fCLOCKLNL==0 || m_fNOCLOCKLNL==0 || m_iTAXA==0))
{
MessageBox("You must define all values to do the clock test!"); 
}

 // ********* fim calculo clock


 // ********* calculo de LRT com ou sem gamma/ invar

if (m_bGAMATEST==TRUE && m_fGAMALNL!=0 && m_fNOGAMALNL!=0) 
	{
	Calcula(m_fNOGAMALNL, m_fGAMALNL, m_sGLRT, m_sGCRITRES, m_sGAMARES, 1, m_fPVALUE);
	}

if (m_bGAMATEST==TRUE && (m_fGAMALNL==0 || m_fNOGAMALNL==0))
{
MessageBox("You must define all values to do the gamma test!");   
}

// ********** fim do gamma/invar


// ********** calculos de LRT entre modelos

if (m_bModelTest==TRUE)     
{

  if (m_bGTR==TRUE)
    {
   LNLMAX=m_fGTRIN;
   FPMAX=GTRFP;
     if (m_bGTRG==TRUE) {FPMAX++;}
     if (m_bGTRI==TRUE) {FPMAX++;}
		
		  if (m_bTRN==TRUE)
		  {
            LNLATUAL=m_fTRNIN;
			FPATUAL=TRNFP;
			if (m_bTRNG==TRUE) {FPATUAL++;}
			if (m_bTRNI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sTRNLRT, m_sTRNCV, m_sTRNRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bHKY==TRUE)
		  {
            LNLATUAL=m_fHKYIN;
			FPATUAL=HKYFP;
			if (m_bHKYG==TRUE) {FPATUAL++;}
			if (m_bHKYI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sHKYLRT, m_sHKYCV, m_sHKYRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bK2P==TRUE)
		  {
            LNLATUAL=m_fK2PIN;
			FPATUAL=K2PFP;
			if (m_bK2PG==TRUE) {FPATUAL++;}
			if (m_bK2PI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sK2PLRT, m_sK2PCV, m_sK2PRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bJC==TRUE)
		  {
            LNLATUAL=m_fJCIN;
			FPATUAL=JCFP;
			if (m_bJCG==TRUE) {FPATUAL++;}
			if (m_bJCI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sJCLRT, m_sJCCV, m_sJCRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bF81==TRUE)
		  {
            LNLATUAL=m_fF81IN;
			FPATUAL=F81FP;
			if (m_bF81G==TRUE) {FPATUAL++;}
			if (m_bF81I==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sF81LRT, m_sF81CV, m_sF81RES, FPMAX-FPATUAL, m_fPVALUE);
			}
  saveme();
  if (m_bSalva==TRUE && salva.GetFileName()!=_T("")) analy++;
  }
 else {
    if (m_bTRN==TRUE)
    {
   
   LNLMAX=m_fTRNIN;
   FPMAX=TRNFP;
     if (m_bTRNG==TRUE) {FPMAX++;}
     if (m_bTRNI==TRUE) {FPMAX++;}
		
		  if (m_bHKY==TRUE)
		  {
            LNLATUAL=m_fHKYIN;
			FPATUAL=HKYFP;
			if (m_bHKYG==TRUE) {FPATUAL++;}
			if (m_bHKYI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sHKYLRT, m_sHKYCV, m_sHKYRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bK2P==TRUE)
		  {
            LNLATUAL=m_fK2PIN;
			FPATUAL=K2PFP;
			if (m_bK2PG==TRUE) {FPATUAL++;}
			if (m_bK2PI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sK2PLRT, m_sK2PCV, m_sK2PRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bJC==TRUE)
		  {
            LNLATUAL=m_fJCIN;
			FPATUAL=JCFP;
			if (m_bJCG==TRUE) {FPATUAL++;}
			if (m_bJCI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sJCLRT, m_sJCCV, m_sJCRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bF81==TRUE)
		  {
            LNLATUAL=m_fF81IN;
			FPATUAL=F81FP;
			if (m_bF81G==TRUE) {FPATUAL++;}
			if (m_bF81I==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sF81LRT, m_sF81CV, m_sF81RES, FPMAX-FPATUAL, m_fPVALUE);
			}
	  saveme();	  
	  if (m_bSalva==TRUE && salva.GetFileName()!=_T("")) analy++;
	}
  
	else {
		if (m_bHKY==TRUE)
    {
   LNLMAX=m_fHKYIN;
   FPMAX=HKYFP;
     if (m_bHKYG==TRUE) {FPMAX++;}
     if (m_bHKYI==TRUE) {FPMAX++;}
		
		  if (m_bF81==TRUE)
		  {
            LNLATUAL=m_fF81IN;
			FPATUAL=F81FP;
			if (m_bF81G==TRUE) {FPATUAL++;}
			if (m_bF81I==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sF81LRT, m_sF81CV, m_sF81RES, FPMAX-FPATUAL, m_fPVALUE);
			}
	 
	      if (m_bK2P==TRUE)
		  {
            LNLATUAL=m_fK2PIN;
			FPATUAL=K2PFP;
			if (m_bK2PG==TRUE) {FPATUAL++;}
			if (m_bK2PI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sK2PLRT, m_sK2PCV, m_sK2PRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bJC==TRUE)
		  {
            LNLATUAL=m_fJCIN;
			FPATUAL=JCFP;
			if (m_bJCG==TRUE) {FPATUAL++;}
			if (m_bJCI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sJCLRT, m_sJCCV, m_sJCRES, FPMAX-FPATUAL, m_fPVALUE);
			}
		saveme();
		if (m_bSalva==TRUE && salva.GetFileName()!=_T("")) analy++;
		}	  
	
		else {

	if (m_bF81==TRUE)
    {
   LNLMAX=m_fF81IN;
   FPMAX=F81FP;
     if (m_bF81G==TRUE) {FPMAX++;}
     if (m_bF81I==TRUE) {FPMAX++;}
		
	      if (m_bK2P==TRUE)
		  {
            MessageBox("Please note that K2P is not a special case of F81, so LRT may not be adequate in this case.\nValues are being calculated anyway. Use them at your own risk.");
			LNLATUAL=m_fK2PIN;
			FPATUAL=K2PFP;
			if (m_bK2PG==TRUE) {FPATUAL++;}
			if (m_bK2PI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sK2PLRT, m_sK2PCV, m_sK2PRES, FPMAX-FPATUAL, m_fPVALUE);
			}

		  if (m_bJC==TRUE)
		  {
            LNLATUAL=m_fJCIN;
			FPATUAL=JCFP;
			if (m_bJCG==TRUE) {FPATUAL++;}
			if (m_bJCI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sJCLRT, m_sJCCV, m_sJCRES, FPMAX-FPATUAL, m_fPVALUE);
			}
		  saveme();  
		  if (m_bSalva==TRUE && salva.GetFileName()!=_T("")) analy++;
		}

		

		else {
				if (m_bK2P==TRUE)
				{
                LNLMAX=m_fK2PIN;
                FPMAX=K2PFP;
                 if (m_bK2PG==TRUE) {FPMAX++;}
                 if (m_bK2PI==TRUE) {FPMAX++;}
		
		  if (m_bJC==TRUE)
		  {
            LNLATUAL=m_fJCIN;
			FPATUAL=JCFP;
			if (m_bJCG==TRUE) {FPATUAL++;}
			if (m_bJCI==TRUE) {FPATUAL++;}
			
			Calcula(LNLATUAL, LNLMAX, m_sJCLRT, m_sJCCV, m_sJCRES, FPMAX-FPATUAL, m_fPVALUE);
			}
		  saveme();
		  if (m_bSalva==TRUE && salva.GetFileName()!=_T("")) analy++;
		}
		}
		}
	}
  }

}

// ********** fim calculo LRT entre modelos

UpdateData(FALSE);
}





void CLRTesterDlg::OnHelp() 
{
MessageBox("For now, please double click the file 'LRTester.h'\nthat must have come with this software.\n\nI hope to fix this in a minute...", "Help not right here yet...");	
}

void CLRTesterDlg::OnSalva() 
{
     
     if (salva.DoModal() == IDOK)
		 {
           UpdateData(TRUE);              
		   analy=1;
		   if(m_dComentario.DoModal()==IDOK)
		   {
			   UpdateData(FALSE);
		   }
		 }
	 
}

void CLRTesterDlg::saveme()
{
if (m_bSalva==TRUE && salva.GetFileName()!=_T(""))
{
    SYSTEMTIME quando;
	CString sem, dia, mes, ano, hora, minuto;
	FILE *fp1;
    
	file=salva.GetFileName();
	GetSystemTime(&quando);
/*	sem=(char)quando.wDayOfWeek;
	dia=(char)quando.wDay;
	mes=(char)quando.wMonth;
	ano=(char)quando.wYear;
	hora=(char)quando.wHour;
	minuto=(char)quando.wMinute;*/
	if (analy==1) 
	{ 
		fp1=fopen(file, "w");
		m_sComentapai = m_dComentario.m_sComenta;
		fprintf(fp1, "LRTester v. 2.0 calculated these data on %s %d %s %d at %d:%d\n\n", sem, dia, mes, ano, hora, minuto);
    	fprintf(fp1, m_sComentapai);
		fprintf(fp1, "\n\nAnalysis number %d \n\n", analy);
		fprintf(fp1, "p-value used: %f\n", m_fPVALUE);

if (m_bModelTest==TRUE)     
{

  if (m_bGTR==TRUE)
    {
	  fprintf(fp1, "GTR   lnL = %-8.2f", m_fGTRIN);
	  if (m_bGTRG==TRUE) { fprintf(fp1, "  with gamma     ");}
	  if (m_bGTRI==TRUE) { fprintf(fp1, "  with invariants");}
	  fprintf(fp1,"\n");	
		  if (m_bTRN==TRUE)
		  {
            fprintf(fp1, "TrN   lnL = %-8.2f", m_fTRNIN);
			fprintf(fp1, "  LRT = %-8s", m_sTRNLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sTRNCV);
			fprintf(fp1, "  Result: %s", m_sTRNRES);
    		if (m_bTRNG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bTRNI==TRUE) {fprintf(fp1, "  with invariants");}
			}

		  if (m_bHKY==TRUE)
		  {
            fprintf(fp1, "\nHKY85 lnL = %-8.2f", m_fHKYIN);
			fprintf(fp1, "  LRT = %-8s", m_sHKYLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sHKYCV);
			fprintf(fp1, "  Result: %s", m_sHKYRES);
			if (m_bHKYG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bHKYI==TRUE) {fprintf(fp1, "  with invariants");}
		  }

		  if (m_bF81==TRUE)
		  {
            fprintf(fp1, "\nF81   lnL = %-8.2f", m_fF81IN);
			fprintf(fp1, "  LRT = %-8s", m_sF81LRT);
			fprintf(fp1, "  crit. value = %-8s", m_sF81CV);
			fprintf(fp1, "  Result: %s", m_sF81RES);
			if (m_bF81G==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bF81I==TRUE) {fprintf(fp1, "  with invariants");}
			}

		  if (m_bK2P==TRUE)
		  {
            fprintf(fp1, "\nK2P   lnL = %-8.2f", m_fK2PIN);
			fprintf(fp1, "  LRT = %-8s", m_sK2PLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sK2PCV);
			fprintf(fp1, "  Result: %s", m_sK2PRES);
			if (m_bK2PG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bK2PI==TRUE) {fprintf(fp1, "  with invariants");}			
		  }

		  if (m_bJC==TRUE)
		  {
            fprintf(fp1, "\nJC    lnL = %-8.2f", m_fTRNIN);
			fprintf(fp1, "  LRT = %-8s", m_sJCLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sJCCV);
			fprintf(fp1, "  Result: %s", m_sJCRES);
			if (m_bJCG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bJCI==TRUE) {fprintf(fp1, "  with invariants");}
			}

  }
 else {
    if (m_bTRN==TRUE)
    {
	  fprintf(fp1, "TrN   lnL = %-8.2f", m_fTRNIN);
	  if (m_bTRNG==TRUE) { fprintf(fp1, "  with gamma     ");}
	  if (m_bTRNI==TRUE) { fprintf(fp1, "  with invariants");}
	  fprintf(fp1,"\n");	

		  if (m_bHKY==TRUE)
		  {
            fprintf(fp1, "HKY85 lnL = %-8.2f", m_fHKYIN);
			fprintf(fp1, "  LRT = %-8s", m_sHKYLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sHKYCV);
			fprintf(fp1, "  Result: %s", m_sHKYRES);
			if (m_bHKYG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bHKYI==TRUE) {fprintf(fp1, "  with invariants");}
		  }

		  if (m_bF81==TRUE)
		  {
            fprintf(fp1, "\nF81   lnL = %-8.2f", m_fF81IN);
			fprintf(fp1, "  LRT = %-8s", m_sF81LRT);
			fprintf(fp1, "  crit. value = %-8s", m_sF81CV);
			fprintf(fp1, "  Result: %s", m_sF81RES);
			if (m_bF81G==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bF81I==TRUE) {fprintf(fp1, "  with invariants");}
			}

		  if (m_bK2P==TRUE)
		  {
            fprintf(fp1, "\nK2P   lnL = %-8.2f", m_fK2PIN);
			fprintf(fp1, "  LRT = %-8s", m_sK2PLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sK2PCV);
			fprintf(fp1, "  Result: %s", m_sK2PRES);
			if (m_bK2PG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bK2PI==TRUE) {fprintf(fp1, "  with invariants");}			
		  }

		  if (m_bJC==TRUE)
		  {
            fprintf(fp1, "\nJC    lnL = %-8.2f", m_fTRNIN);
			fprintf(fp1, "  LRT = %-8s", m_sJCLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sJCCV);
			fprintf(fp1, "  Result: %s", m_sJCRES);
			if (m_bJCG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bJCI==TRUE) {fprintf(fp1, "  with invariants");}
			}

  }
else {
	if (m_bHKY==TRUE)
    {
	  fprintf(fp1, "HKY85 lnL = %-8.2f", m_fHKYIN);
	  if (m_bHKYG==TRUE) { fprintf(fp1, "  with gamma     ");}
	  if (m_bHKYI==TRUE) { fprintf(fp1, "  with invariants");}
	  fprintf(fp1,"\n");	

		  if (m_bF81==TRUE)
		  {
            fprintf(fp1, "F81   lnL = %-8.2f", m_fF81IN);
			fprintf(fp1, "  LRT = %-8s", m_sF81LRT);
			fprintf(fp1, "  crit. value = %-8s", m_sF81CV);
			fprintf(fp1, "  Result: %s", m_sF81RES);
			if (m_bF81G==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bF81I==TRUE) {fprintf(fp1, "  with invariants");}
			}

		  if (m_bK2P==TRUE)
		  {
            fprintf(fp1, "\nK2P   lnL = %-8.2f", m_fK2PIN);
			fprintf(fp1, "  LRT = %-8s", m_sK2PLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sK2PCV);
			fprintf(fp1, "  Result: %s", m_sK2PRES);
			if (m_bK2PG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bK2PI==TRUE) {fprintf(fp1, "  with invariants");}			
		  }

		  if (m_bJC==TRUE)
		  {
            fprintf(fp1, "\nJC    lnL = %-8.2f", m_fTRNIN);
			fprintf(fp1, "  LRT = %-8s", m_sJCLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sJCCV);
			fprintf(fp1, "  Result: %s", m_sJCRES);
			if (m_bJCG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bJCI==TRUE) {fprintf(fp1, "  with invariants");}
			}

  }
	else {

	if (m_bF81==TRUE)
    {
	  fprintf(fp1, "F81   lnL = %-8.2f", m_fF81IN);
	  if (m_bF81G==TRUE) { fprintf(fp1, "  with gamma     ");}
	  if (m_bF81I==TRUE) { fprintf(fp1, "  with invariants");}
	  fprintf(fp1,"\n");	

		  if (m_bK2P==TRUE)
		  {
            fprintf(fp1, "K2P   lnL = %-8.2f", m_fK2PIN);
			fprintf(fp1, "  LRT = %-8s", m_sK2PLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sK2PCV);
			fprintf(fp1, "  Result: %s", m_sK2PRES);
			if (m_bK2PG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bK2PI==TRUE) {fprintf(fp1, "  with invariants");}			
		  }

		  if (m_bJC==TRUE)
		  {
            fprintf(fp1, "\nJC    lnL = %-8.2f", m_fTRNIN);
			fprintf(fp1, "  LRT = %-8s", m_sJCLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sJCCV);
			fprintf(fp1, "  Result: %s", m_sJCRES);
			if (m_bJCG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bJCI==TRUE) {fprintf(fp1, "  with invariants");}
			}

  }
	else {
	if (m_bK2P==TRUE)
    {
	  fprintf(fp1, "K2P   lnL = %-8.2f", m_fK2PIN);
	  if (m_bK2PG==TRUE) { fprintf(fp1, "  with gamma     ");}
	  if (m_bK2PI==TRUE) { fprintf(fp1, "  with invariants");}
	  fprintf(fp1,"\n");	

		  if (m_bJC==TRUE)
		  {
            fprintf(fp1, "JC    lnL = %-8.2f", m_fTRNIN);
			fprintf(fp1, "  LRT = %-8s", m_sJCLRT);
			fprintf(fp1, "  crit. value = %-8s", m_sJCCV);
			fprintf(fp1, "  Result: %s", m_sJCRES);
			if (m_bJCG==TRUE) {fprintf(fp1, "  with gamma     ");}
			if (m_bJCI==TRUE) {fprintf(fp1, "  with invariants");}
			}

	} //do if k2p

	} //do if modeltest
	} //do if analy 1
}
  }


		//resto analysis 1
	}
	else {
       fp1=fopen(file, "a"); 
	   fprintf(fp1, "\nAnalysis number %d\n", analy);
    
	   // resto
	}
fclose(fp1);
}
else
{

	if (m_bSalva==TRUE && salva.GetFileName()==_T(""))
	{
	 MessageBox("Please enter some file name in the 'Save As...' dialog!", "No File name entered");
     OnSalva();
	}
}
}
}